searchNodes=[{"doc":"An experimental light-weight module to help with integrating Vite into your Phoenix project and watching for any code change in Vite's side. This module is basically a simplified version of the esbuild module that comes with Phoenix framework. Profiles To simplify the usage, while vite_phoenix retains the ability to let user define multiple profiles, it also comes with a default config hard-coded inside the module, so that users won't need to provide the whole profile in their config.exs. Project name That being said, in order to make it work with arbitrary project names set up by Vite during npm create vite@latest , users still need to define the project name in config.exs that matches the folder name under assets/js . The config should look like this: config :vite_phoenix , project_name : &quot;my-vite-project&quot;","ref":"VitePhoenix.html","title":"VitePhoenix","type":"module"},{"doc":"","ref":"VitePhoenix.html#config_for/1","title":"VitePhoenix.config_for/1","type":"function"},{"doc":"","ref":"VitePhoenix.html#run/2","title":"VitePhoenix.run/2","type":"function"},{"doc":"An experimental light-weight module to help with integrating Vite into your Phoenix project and watching for any code change in Vite's side. Background Prerequisites Installation Setup steps Limitations See also","ref":"readme.html","title":"VitePhoenix","type":"extras"},{"doc":"Starting from Phoenix 1.6, esbuild is used to bundle JavaScript files and other assets instead of webpack. On the other hand, the latest version of Vue 3 recommends using Vite for building. Vite also supports other templates such as Lit , React , Preact , and Svelte , etc. Since during development, Phoenix's esbuild will watch for changes inside the assets folder and automatically re-bundles, and that it doesn't support *.vue files, *.svelte files, etc. directly, without writing a custom build script, it's relatively difficult to integrate Vite into a Phoenix project. Therefore, this tiny module serves to make such process a little bit easier. With correct setup, VitePhoenix will automatically start watching for changes in your Vite project when you execute mix phx.server . It will rebuild your files and put them inside the priv/static folder in your Phoenix project.","ref":"readme.html#background","title":"VitePhoenix - Background","type":"extras"},{"doc":"Unlike the esbuild module that comes with Phoenix 1.6+, VitePhoenix does NOT install Node.js for you. Since it runs npx for you, you will need to install Node.js before using VitePhoenix.","ref":"readme.html#prerequisites","title":"VitePhoenix - Prerequisites","type":"extras"},{"doc":"Adding vite_phoenix to your list of dependencies in mix.exs : def deps do [ { :vite_phoenix , &quot;~&gt; 0.1.3&quot; } ] end Then run mix deps.get .","ref":"readme.html#installation","title":"VitePhoenix - Installation","type":"extras"},{"doc":"VitePhoenix basically delegates all JavaScript stuffs to Vite, so in order to make it work, there are a few steps that need to be configured. After creating the project folder with mix phx.new , navigate to assets/js folder under your project, and run either npm create vue @latest to bootstrap your Vue 3 + Vite project, or npm create vite @latest &lt; your - vite - project - name &gt; and select available templates to bootstrap your project. Install VitePhoenix through the steps in Installation . In your config/config.exs , configure the project name for VitePhoenix. Your project name here has to match the name you specify when running either npm create vue@latest or npm create vite@latest config :vite_phoenix , project_name : &quot;&lt;your-vite-project-name&gt;&quot; , js_version : &quot;es2020&quot; # Optionally provides the JS version for ESBuild in Vite. Default to &quot;esnext&quot; In your config/dev.exs , comment out or remove esbuild watcher for your Phoenix project, and add watcher for VitePhoenix. config :my_phoenix , MyPhoenix , watchers : [ # Start the esbuild watcher by calling Esbuild.install_and_run(:default, args) # esbuild: {Esbuild, :install_and_run, [:default, ~w(--sourcemap=inline --watch)]}, vite_phoenix : { VitePhoenix , :run , [ :default , ~w(--sourcemap --watch --emptyOutDir) ] } ] By default, Vite will build everything under your Vite project folder and create a single index.html . In order to make use of such index.html built by Vite, you would need to change your PageController that comes with any new Phoenix project, or any controller that serves as the entry point of your Phoenix project to send index.html instead. defmodule MyPhoenixWeb.PageController do use MyPhoenixWeb , :controller def index ( conn , _params ) do conn |&gt; put_resp_header ( &quot;Content-Type&quot; , &quot;text/html; charset=utf-8&quot; ) |&gt; send_file ( 200 , Application . app_dir ( :my_phoenix , &quot;priv/static/index.html&quot; ) ) end end (Optional) Delete templates/page/index.html.heex and other files under templates/layout . (Optional) Delete esbuild-related lines per Phoenix's guide to remove esbuild . (Optional) If you're also using vue-router and other routers for SPAs, you would also need to configure your router.ex to delegate non-Phoenix routes to your JavaScript router by adding a catch-all route. Note that the order of routes matters in router.ex . scope &quot;/api&quot; , MyPhoenixWeb do pipe_through :browser get &quot;/some_api&quot; , SomeApiController , :some_action end scope &quot;/&quot; , MyPhoenixWeb do pipe_through :browser get &quot;/*path&quot; , PageController , :index end (Optional) Add files not included in the static path in your endpoint.ex plug Plug.Static , at : &quot;/&quot; , from : :my_phoenix , gzip : false , only : ~w(assets fonts images favicon.ico robots.txt vite.svg) Run mix phx.server and visit http://localhost:4000 to see your JavaScript/TypeScript SPA powered by Vite.","ref":"readme.html#setup-steps","title":"VitePhoenix - Setup steps","type":"extras"},{"doc":"As aforementioned, since VitePhoenix basically delegates everything JavaScript/TypeScript to Vite, and it doesn't use Phoenix's templates, it neither benefits from Phoenix's hot reload nor Vite's HMR. Even though Vite does rebuilds and puts latest files into priv/static when anything is changed inside your Vite project, currently users have to refresh to see the latest result.","ref":"readme.html#limitations","title":"VitePhoenix - Limitations","type":"extras"},{"doc":"Phoenix Framework Phoenix's esbuild module Vite Elixir esbuild Node.js","ref":"readme.html#see-also","title":"VitePhoenix - See also","type":"extras"},{"doc":"","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Add the ability to specify JS version for ESBuild in Vite.","ref":"changelog.html#v0-1-3-2023-01-20","title":"Change Log - v0.1.3 (2023-01-20)","type":"extras"},{"doc":"Fix relative path to the js folder when used as a dependency.","ref":"changelog.html#v0-1-2-2023-01-17","title":"Change Log - v0.1.2 (2023-01-17)","type":"extras"},{"doc":"Remove empty environment variable from mix.exs","ref":"changelog.html#v0-1-1-2023-01-17","title":"Change Log - v0.1.1 (2023-01-17)","type":"extras"},{"doc":"Initial version.","ref":"changelog.html#v0-1-0-2023-01-17","title":"Change Log - v0.1.0 (2023-01-17)","type":"extras"}]